/*
 * Nenad Taskovic 5/93
 * e-mail: neyt@fon.bg.ac.yu
 * www: http://fon.fon.bg.ac.yu/~neyt/
 */

#include "hrs.h"
#include <conio.h>

int XR = 0, N, Z;

extern Lista *promenljive, *naredbe, *labele;


#pragma argsused
Cvor *clr (void *arg1, void *arg2)
{
   ((Promenljiva *) arg1)->vrednost[XR] = 0;
   return NULL;
}

Cvor *add (void *arg1, void *arg2)
{
   ((Promenljiva *) arg1)->vrednost[0] += ((Promenljiva *) arg2)->vrednost[XR];
   return NULL;
}

Cvor *sub (void *arg1, void *arg2)
{
   ((Promenljiva *) arg1)->vrednost[0] -= ((Promenljiva *) arg2)->vrednost[XR];
   return NULL;
}

Cvor *mul (void *arg1, void *arg2)
{
   ((Promenljiva *) arg1)->vrednost[0] *= ((Promenljiva *) arg2)->vrednost[XR];
   return NULL;
}

Cvor *div (void *arg1, void *arg2)
{
   ((Promenljiva *) arg1)->vrednost[0] /= ((Promenljiva *) arg2)->vrednost[XR];
   return NULL;
}

Cvor *mov (void *arg1, void *arg2)
{
   ((Promenljiva *) arg1)->vrednost[0] = ((Promenljiva *) arg2)->vrednost[XR];
   return NULL;
}

#pragma argsused
Cvor *inc (void *arg1, void *arg2)
{
   ((Promenljiva *) arg1)->vrednost[0] ++;
   return NULL;
}

#pragma argsused
Cvor *dec (void *arg1, void *arg2)
{
   ((Promenljiva *) arg1)->vrednost[0] --;
   return NULL;
}

#pragma argsused
Cvor *tst (void *arg1, void *arg2)
{
   N = ( ((Promenljiva *) arg1)->vrednost[0] < 0 );
   Z = ( ((Promenljiva *) arg1)->vrednost[0] == 0 );
   return NULL;
}

Cvor *cmp (void *arg1, void *arg2)
{
   N = ( ((Promenljiva *) arg1)->vrednost[0] < ((Promenljiva *) arg2)->vrednost[XR] );
   Z = ( ((Promenljiva *) arg1)->vrednost[0] == ((Promenljiva *) arg2)->vrednost[XR] );
   return NULL;
}

#pragma argsused
Cvor *jmp (void *arg1, void *arg2)
{
   return ( ((Labela *) arg1)->nar_adr );
}

#pragma argsused
Cvor *blt (void *arg1, void *arg2)
{
   return ( N ? ((Labela *) arg1)->nar_adr : NULL );
}

#pragma argsused
Cvor *ble (void *arg1, void *arg2)
{
   return ( (N || Z) ? ((Labela *) arg1)->nar_adr : NULL );
}

#pragma argsused
Cvor *beq (void *arg1, void *arg2)
{
   return ( Z ? ((Labela *) arg1)->nar_adr : NULL );
}

#pragma argsused
Cvor *bge (void *arg1, void *arg2)
{
   return ( !N ? ((Labela *) arg1)->nar_adr : NULL );
}

#pragma argsused
Cvor *bgt (void *arg1, void *arg2)
{
   return ( (!N && !Z) ? ((Labela *) arg1)->nar_adr : NULL );
}

#pragma argsused
Cvor *bne (void *arg1, void *arg2)
{
   return ( !Z ? ((Labela *) arg1)->nar_adr : NULL );
}

#pragma argsused
Cvor *halt (void *arg1, void *arg2)
{
   printf("Program zaustavljen naredbom HALT.\n");
   return NULL;
}

#pragma argsused
Cvor *setxr (void *arg1, void *arg2)
{
   XR = 0;
   return NULL;
}

#pragma argsused
Cvor *incxr (void *arg1, void *arg2)
{
   XR ++;
   return NULL;
}

void postavi_promenljive (void)
{
   Promenljiva *p;
   int i;

   printf("Vrednosti za nizove odvajati razmakom!\n");
   na_pocetak(promenljive);
   while (!kraj_liste(promenljive)) {
      p = (Promenljiva *) podatak(promenljive);
      printf("%s[%d] > ", p->naziv, p->duzina);
      for (i=0; i < p->duzina; i++)
         scanf(" %d", &p->vrednost[i]);
      napred(promenljive);
   }
}

void ispisi_promenljive (void)
{
   Promenljiva *p;
   int i;

   na_pocetak(promenljive);
   while (!kraj_liste(promenljive)) {
      p = (Promenljiva *) podatak(promenljive);
      printf("%s[%d] >", p->naziv, p->duzina);
      for (i=0; i < p->duzina; i++)
         printf(" %d", p->vrednost[i]);
      printf("\n");
      napred(promenljive);
   }
}


void izvrsi_program (void)
{
   int naredba = 20;
   Naredba *n;
   Cvor *skok;

   postavi_promenljive();

   XR = 0;
   na_pocetak(naredbe);
   while ( !kraj_liste(naredbe) && (naredba != HALT) ) {
      n = (Naredba *) podatak(naredbe);
      if ( (skok=nar_fun[n->kod_naredbe](n->arg[0], n->arg[1])) != NULL )
         postavi_tekuci(naredbe, skok);
      else
         napred(naredbe);
/*      printf("\n%s\n", stringovi_instrukcija[n->kod_naredbe]);
      ispisi_promenljive();
      getch(); */
   }
   ispisi_promenljive();
}

